Package com.io7m.cardant.model

# Record Class CATypeScalarType.Integral

java.lang.Object
java.lang.Record
com.io7m.cardant.model.CATypeScalarType.Integral

Record Components:
  `packageIdentifier` - The package to which this type belongs
  `name` - The type name
  `description` - A humanly-readable description of the type
  `rangeLower` - The lower bound (inclusive)
  `rangeUpper` - The upper bound (inclusive)

All Implemented Interfaces:
  `CATypeScalarType`

Enclosing interface:
  `CATypeScalarType`

public static record CATypeScalarType.Integral(CATypePackageIdentifier packageIdentifier, com.io7m.lanark.core.RDottedName name, String description, long rangeLower, long rangeUpper) extends Record implements CATypeScalarType
An integer type.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface com.io7m.cardant.model.CATypeScalarType

  `CATypeScalarType.Integral, CATypeScalarType.Kind, CATypeScalarType.Monetary, CATypeScalarType.Real, CATypeScalarType.Text, CATypeScalarType.Time`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Integral(CATypePackageIdentifier packageIdentifier, com.io7m.lanark.core.RDottedName name, String description, long rangeLower, long rangeUpper)`
  An integer type.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `description()`
  Returns the value of the `description` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `boolean`
  `isValid(long value)`
  `CATypeScalarType.Kind`
  `kind()`
  `com.io7m.lanark.core.RDottedName`
  `name()`
  Returns the value of the `name` record component.
  `CATypePackageIdentifier`
  `packageIdentifier()`
  Returns the value of the `packageIdentifier` record component.
  `long`
  `rangeLower()`
  Returns the value of the `rangeLower` record component.
  `long`
  `rangeUpper()`
  Returns the value of the `rangeUpper` record component.
  `String`
  `showConstraint()`
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `CATypeScalarType`
  `withName(com.io7m.lanark.core.RDottedName newName)`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Integral

    public Integral(CATypePackageIdentifier packageIdentifier, com.io7m.lanark.core.RDottedName name, String description, long rangeLower, long rangeUpper)
    An integer type.

- ## Method Details

  - ### withName

    public CATypeScalarType withName(com.io7m.lanark.core.RDottedName newName)
    Specified by:
      `withName` in interface `CATypeScalarType`
    Parameters:
      `newName` - The new name
    Returns:
      This type with a new name

  - ### kind

    public CATypeScalarType.Kind kind()
    Specified by:
      `kind` in interface `CATypeScalarType`
    Returns:
      The internal type kind

  - ### showConstraint

    public String showConstraint()
    Specified by:
      `showConstraint` in interface `CATypeScalarType`
    Returns:
      A humanly-readable description of this type's value constraints

  - ### isValid

    public boolean isValid(long value)
    Parameters:
      `value` - The value
    Returns:
      `true` if the given value is in the range for this type

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with '=='.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### packageIdentifier

    public CATypePackageIdentifier packageIdentifier()
    Returns the value of the `packageIdentifier` record component.
    Specified by:
      `packageIdentifier` in interface `CATypeScalarType`
    Returns:
      the value of the `packageIdentifier` record component

  - ### name

    public com.io7m.lanark.core.RDottedName name()
    Returns the value of the `name` record component.
    Specified by:
      `name` in interface `CATypeScalarType`
    Returns:
      the value of the `name` record component

  - ### description

    public String description()
    Returns the value of the `description` record component.
    Specified by:
      `description` in interface `CATypeScalarType`
    Returns:
      the value of the `description` record component

  - ### rangeLower

    public long rangeLower()
    Returns the value of the `rangeLower` record component.
    Returns:
      the value of the `rangeLower` record component

  - ### rangeUpper

    public long rangeUpper()
    Returns the value of the `rangeUpper` record component.
    Returns:
      the value of the `rangeUpper` record component